import BaseModel from './BaseModel';
import { index, getModelForClass, prop, DocumentType } from '@typegoose/typegoose';


/**
  * 购买记录
*/

export class BuyRecord {
    @prop({ required: true })
    id: number; //物品id标识
    @prop({ required: true })
    time: Date; //购买时间
}


/**
  * 活动系统 - 新手限定、每日限购、每周限购
*/
@index({ roleId: 1 })

export default class Activity_Shop extends BaseModel {
    @prop({ required: true })
    activityId: number;				// 活动Id
    @prop({ required: true })
    roleId: string;			        // 用户Id
    @prop({ required: true })
    roundIndex: number;				// 第几个周期，从1开始
    @prop({ required: true })
    records: BuyRecord[];		    // 购买记录

    //购买领取奖励的记录
    public static async addRecord(activityId: number, roleId: string, roundIndex: number, id: number) {
        let result: ActivityShopModelType = await ActivityShopModel.findOneAndUpdate({ roleId, activityId, roundIndex },
            { $push: { records: { id, time: new Date() } } }, { upsert: true, new: true }).lean(true);
        return result;
    }

    //根据活动id查询活动数据
    public static async findData(activityId: number, roleId: string, roundIndex: number) {
        let result: ActivityShopModelType = await ActivityShopModel.findOne({ roleId, activityId, roundIndex }).lean(true);
        return result;
    }

    //删除活动领取记录
    public static async deleteActivity(activityId: number, roleId: string, roundIndex: number) {
        await ActivityShopModel.deleteMany({ roleId, activityId, roundIndex });
    }
}

export const ActivityShopModel = getModelForClass(Activity_Shop);

export interface ActivityShopModelType extends Pick<DocumentType<Activity_Shop>, keyof Activity_Shop> { }
export type ActivityShopModelTypeParam = Partial<ActivityShopModelType>; // 将所有字段变成可选项